TF_EncryptorImpl< SCHEME_OPTIONS > Class Template Reference

_ More...

`#include <pubkey.h>`

Inheritance diagram for TF_EncryptorImpl< SCHEME_OPTIONS >:

## Public Types

typedef SCHEME_OPTIONS::PublicKey | KeyClass
typedef SCHEME_OPTIONS | SchemeOptions

## Public Member Functions

const KeyClass & | GetKey () const
KeyClass & | AccessKey ()
PublicKey & | AccessPublicKey ()
const PublicKey & | GetPublicKey () const
PrivateKey & | AccessPrivateKey ()
const PrivateKey & | GetPrivateKey () const
const KeyClass & | GetTrapdoorFunction () const
PK_MessageAccumulator * | NewSignatureAccumulator (RandomNumberGenerator &rng) const
PK_MessageAccumulator * | NewVerificationAccumulator () const
std::string | AlgorithmName () const
void | Encrypt (RandomNumberGenerator &rng, const byte *plaintext, size_t plaintextLength, byte *ciphertext, const NameValuePairs &parameters=g_nullNameValuePairs) const
| encrypt a byte string More...
bool | ParameterSupported (const char *name) const
size_t | FixedMaxPlaintextLength () const
size_t | FixedCiphertextLength () const
size_t | MaxPlaintextLength (size_t ciphertextLength) const
size_t | CiphertextLength (size_t plaintextLength) const
virtual BufferedTransformation * | CreateEncryptionFilter (RandomNumberGenerator &rng, BufferedTransformation *attachment=NULL, const NameValuePairs &parameters=g_nullNameValuePairs) const
| create a new encryption filter More...
CryptoMaterial & | AccessMaterial ()
| returns a reference to the crypto material used by this object
const CryptoMaterial & | GetMaterial () const
| returns a const reference to the crypto material used by this object
void | BERDecode (BufferedTransformation &bt)
| for backwards compatibility, calls AccessMaterial().Load(bt)
void | DEREncode (BufferedTransformation &bt) const
| for backwards compatibility, calls GetMaterial().Save(bt)
virtual Clonable * | Clone () const
| this is not implemented by most classes yet

## Static Public Member Functions

static std::string | StaticAlgorithmName ()

## Protected Types

typedef RandomizedTrapdoorFunction | TrapdoorFunctionInterface
typedef PK_EncryptionMessageEncodingMethod | MessageEncodingInterface

## Protected Member Functions

const TF_EncryptorBase::MessageEncodingInterface & | GetMessageEncodingInterface () const
const TrapdoorFunctionBounds & | GetTrapdoorFunctionBounds () const
const TF_EncryptorBase::TrapdoorFunctionInterface & | GetTrapdoorFunctionInterface () const
HashIdentifier | GetHashIdentifier () const
size_t | GetDigestSize () const
size_t | PaddedBlockByteLength () const
size_t | PaddedBlockBitLength () const

## Detailed Description

### template<class SCHEME_OPTIONS>
class TF_EncryptorImpl< SCHEME_OPTIONS >

_

Definition at line 457 of file pubkey.h.

## Member Function Documentation

void TF_EncryptorBase::Encrypt | ( | RandomNumberGenerator & | rng,
|  | const byte * | plaintext,
|  | size_t | plaintextLength,
|  | byte * | ciphertext,
|  | const NameValuePairs & | parameters = `g_nullNameValuePairs`
| ) |  | const

virtual inherited

encrypt a byte string

Precondition
  CiphertextLength(plaintextLength) != 0 (i.e., plaintext isn't too long)
  size of ciphertext == CiphertextLength(plaintextLength)

Implements PK_Encryptor.

virtual BufferedTransformation* PK_Encryptor::CreateEncryptionFilter | ( | RandomNumberGenerator & | rng,
|  | BufferedTransformation * | attachment = `NULL`,
|  | const NameValuePairs & | parameters = `g_nullNameValuePairs`
| ) |  | const

virtual inherited

create a new encryption filter

Note
  The caller is responsible for deleting the returned pointer.
  Encoding parameters should be passed in the "EP" channel.

The documentation for this class was generated from the following file:

- pubkey.h